(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ng-loading-spinner', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-loading-spinner'] = {}, global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, rxjs, operators) { 'use strict';

    var NgLoadingSpinnerService = /** @class */ (function () {
        function NgLoadingSpinnerService() {
            /** Progress state */
            this.state = new rxjs.Subject();
            this.isSpinning1 = false;
        }
        /** Start spinning */
        NgLoadingSpinnerService.prototype.start = function () {
            if (this.isSpinning()) {
                return;
            }
            this.isSpinning1 = true;
            this.state.next(true);
        };
        /** Stop spinning */
        NgLoadingSpinnerService.prototype.stop = function () {
            if (!this.isSpinning()) {
                return;
            }
            this.isSpinning1 = false;
            /** if spinning stop it */
            this.state.next(false);
        };
        NgLoadingSpinnerService.prototype.isSpinning = function () {
            return this.isSpinning1;
        };
        return NgLoadingSpinnerService;
    }());
    NgLoadingSpinnerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgLoadingSpinnerService_Factory() { return new NgLoadingSpinnerService(); }, token: NgLoadingSpinnerService, providedIn: "root" });
    NgLoadingSpinnerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgLoadingSpinnerService.ctorParameters = function () { return []; };

    var NgLoadingSpinnerInterceptor = /** @class */ (function () {
        function NgLoadingSpinnerInterceptor(spinnerService) {
            this.spinnerService = spinnerService;
            this.requestCounter = 0;
        }
        NgLoadingSpinnerInterceptor.prototype.intercept = function (req, next) {
            var _this = this;
            this.spinnerService.start();
            this.requestCounter++;
            return next.handle(req)
                .pipe(operators.finalize(function () {
                _this.requestCounter--;
                if (_this.requestCounter === 0) {
                    _this.spinnerService.stop();
                }
            }));
        };
        return NgLoadingSpinnerInterceptor;
    }());
    NgLoadingSpinnerInterceptor.decorators = [
        { type: i0.Injectable }
    ];
    NgLoadingSpinnerInterceptor.ctorParameters = function () { return [
        { type: NgLoadingSpinnerService }
    ]; };

    var NgLoadingSpinnerComponent = /** @class */ (function () {
        function NgLoadingSpinnerComponent(ngLoadingSpinnerService) {
            var _this = this;
            this.ngLoadingSpinnerService = ngLoadingSpinnerService;
            this.color = '#000000';
            this.top = 105;
            this.ngLoadingSpinnerService.state.subscribe(function (r) {
                _this.show = r;
            });
        }
        NgLoadingSpinnerComponent.prototype.ngOnInit = function () {
        };
        NgLoadingSpinnerComponent.prototype.ngOnDrestroy = function () {
            this.ngLoadingSpinnerService.state.unsubscribe();
        };
        return NgLoadingSpinnerComponent;
    }());
    NgLoadingSpinnerComponent.decorators = [
        { type: i0.Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'ng-loading-spinner',
                    template: "\n    <div [hidden]=\"!show\" id=\"loading-bar-spinner\" [style.top]=\"top + 'px'\">\n      <div [style.borderColor]=\"color\" class=\"spinner-icon\"></div>\n    </div>\n  ",
                    styles: ["@-webkit-keyframes ball-clip-rotate{0%{transform:rotate(0deg)}50%{transform:rotate(180deg)}to{transform:rotate(1turn)}}@keyframes ball-clip-rotate{0%{transform:rotate(0deg)}50%{transform:rotate(180deg)}to{transform:rotate(1turn)}}#loading-bar,#loading-bar-spinner{-webkit-pointer-events:none;pointer-events:none;transition:all linear;transition-duration:.35s}#loading-bar-spinner.ng-enter,#loading-bar-spinner.ng-leave.ng-leave-active,#loading-bar.ng-enter,#loading-bar.ng-leave.ng-leave-active{filter:alpha(opacity=0);opacity:0}#loading-bar-spinner.ng-enter.ng-enter-active,#loading-bar-spinner.ng-leave,#loading-bar.ng-enter.ng-enter-active,#loading-bar.ng-leave{filter:alpha(opacity=100);opacity:1}#loading-bar .bar{background:rgba(0,0,0,.15);border-bottom-right-radius:1px;border-top-right-radius:1px;height:70px;left:0;position:fixed;top:0;transition:width;transition-duration:.35s;width:100%;z-index:10002}#loading-bar .peg{border-radius:100%;box-shadow:1px 0 6px 1px #fff;filter:alpha(opacity=45);height:2px;opacity:.45;position:absolute;right:0;top:0;width:70px;z-index:99999}#loading-bar-spinner{background:#fff;border-radius:50%;box-shadow:0 2px 5px rgba(0,0,0,.16),0 2px 10px rgba(0,0,0,.12);left:50%;margin-left:-28px;padding:14px;position:fixed;text-align:center;top:105px;z-index:999999}#loading-bar-spinner .spinner-icon{-webkit-animation:ball-clip-rotate .75s linear infinite;animation:ball-clip-rotate .75s linear infinite;background:transparent!important;border:2px solid red;border-bottom-color:transparent!important;border-radius:100%;display:inline-block;float:left;height:28px;margin:0;width:28px}#loading-bar-spinner:after,#loading-bar-spinner:before{content:\" \";display:table}#loading-bar-spinner:after{clear:both}"]
                },] }
    ];
    NgLoadingSpinnerComponent.ctorParameters = function () { return [
        { type: NgLoadingSpinnerService }
    ]; };
    NgLoadingSpinnerComponent.propDecorators = {
        color: [{ type: i0.Input }],
        top: [{ type: i0.Input }]
    };

    var NgLoadingSpinnerModule = /** @class */ (function () {
        function NgLoadingSpinnerModule() {
        }
        return NgLoadingSpinnerModule;
    }());
    NgLoadingSpinnerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgLoadingSpinnerComponent],
                    imports: [],
                    exports: [NgLoadingSpinnerComponent],
                    providers: [NgLoadingSpinnerService]
                },] }
    ];

    /*
     * Public API Surface of ng-loading-spinner
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgLoadingSpinnerComponent = NgLoadingSpinnerComponent;
    exports.NgLoadingSpinnerInterceptor = NgLoadingSpinnerInterceptor;
    exports.NgLoadingSpinnerModule = NgLoadingSpinnerModule;
    exports.NgLoadingSpinnerService = NgLoadingSpinnerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-loading-spinner.umd.js.map
